library ieee;
use ieee.std_logic_1164.all;

entity RegDecBidirect is
   port (DR_GA, EntreeDonnees, Horloge: in std_logic;
   Q0, Q1, Q2, Q3: buffer std_logic);
end entity RegDecBidirect;

architecture FonctionLogique of RegDecBidirect is
component BascD is
   port(D, Horloge: in std_logic; Q: out std_logic);
end component BascD;

signal D0, D1, D2, D3: std_logic;
begin
   D0 <= (EntreeDonnees and DR_GA) or (not DR_GA and Q1);
   D1 <= (Q0 and DR_GA) or (not DR_GA and Q2);
   D2 <= (Q1 and DR_GA) or (not DR_GA and Q3);
   D3 <= (Q2 and DR_GA) or (not DR_GA and EntreeDonnees);
   BASC0: BascD port map(D => D0, Horloge => Horloge, Q => Q0);
   BASC1: BascD port map(D => D1, Horloge => Horloge, Q => Q1);
   BASC2: BascD port map(D => D2, Horloge => Horloge, Q => Q2);
   BASC3: BascD port map(D => D3, Horloge => Horloge, Q => Q3);
end architecture FonctionLogique;